<!DOCTYPE html>
<!-- Generated by pkgdown: do not edit by hand --><html lang="en"><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8"><meta charset="utf-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no"><title>TODOs • qstnr</title><script src="lightswitch.js"></script><script src="deps/jquery-3.6.0/jquery-3.6.0.min.js"></script><meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no"><link href="deps/bootstrap-5.3.1/bootstrap.min.css" rel="stylesheet"><script src="deps/bootstrap-5.3.1/bootstrap.bundle.min.js"></script><link href="deps/font-awesome-6.5.2/css/all.min.css" rel="stylesheet"><link href="deps/font-awesome-6.5.2/css/v4-shims.min.css" rel="stylesheet"><script src="deps/headroom-0.11.0/headroom.min.js"></script><script src="deps/headroom-0.11.0/jQuery.headroom.min.js"></script><script src="deps/bootstrap-toc-1.0.1/bootstrap-toc.min.js"></script><script src="deps/clipboard.js-2.0.11/clipboard.min.js"></script><script src="deps/search-1.0.0/autocomplete.jquery.min.js"></script><script src="deps/search-1.0.0/fuse.min.js"></script><script src="deps/search-1.0.0/mark.min.js"></script><!-- pkgdown --><script src="pkgdown.js"></script><meta property="og:title" content="TODOs"><meta name="twitter:card" content="summary"><meta name="twitter:creator" content="@2BSalim"><meta name="twitter:site" content="@2BSalim"><meta name="robots" content="noindex"><script src="https://rpkg.dev/counter-dev.min.js" data-id="4c4963fe-9fcf-4d81-95bb-2135e114b85b" data-utcoffset="1"></script></head><body>
    <a href="#main" class="visually-hidden-focusable">Skip to contents</a>


    <nav class="navbar navbar-expand-lg fixed-top " aria-label="Site navigation"><div class="container">

    <a class="navbar-brand me-2" href="index.html">qstnr</a>

    <small class="nav-text text-danger me-auto" data-bs-toggle="tooltip" data-bs-placement="bottom" title="In-development version">0.0.9000</small>


    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbar" aria-controls="navbar" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>

    <div id="navbar" class="collapse navbar-collapse ms-3">
      <ul class="navbar-nav me-auto"><li class="nav-item"><a class="nav-link" href="reference/index.html">Reference</a></li>
      </ul><ul class="navbar-nav"><li class="nav-item"><form class="form-inline" role="search">
 <input class="form-control" type="search" name="search-input" id="search-input" autocomplete="off" aria-label="Search site" placeholder="Search for" data-search-index="search.json"></form></li>
<li class="nav-item"><a class="external-link nav-link" href="https://gitlab.com/rpkg.dev/qstnr/" aria-label="GitLab"><span class="fa fab fa-gitlab fa-lg"></span></a></li>
<li class="nav-item dropdown">
  <button class="nav-link dropdown-toggle" type="button" id="dropdown-lightswitch" data-bs-toggle="dropdown" aria-expanded="false" aria-haspopup="true" aria-label="Light switch"><span class="fa fa-sun"></span></button>
  <ul class="dropdown-menu dropdown-menu-end" aria-labelledby="dropdown-lightswitch"><li><button class="dropdown-item" data-bs-theme-value="light"><span class="fa fa-sun"></span> Light</button></li>
    <li><button class="dropdown-item" data-bs-theme-value="dark"><span class="fa fa-moon"></span> Dark</button></li>
    <li><button class="dropdown-item" data-bs-theme-value="auto"><span class="fa fa-adjust"></span> Auto</button></li>
  </ul></li>
      </ul></div>


  </div>
</nav><div class="container template-title-body">
<div class="row">
  <main id="main" class="col-md-9"><div class="page-header">

      <h1>TODOs</h1>
      <small class="dont-index">Source: <a href="https://gitlab.com/rpkg.dev/qstnr/blob/HEAD/TODO.md" class="external-link"><code>TODO.md</code></a></small>
    </div>

<div id="todos" class="section level1">

<ul><li><p>move most of default config to pkg fokus</p></li>
<li><p>implement target iterators handling</p></li>
<li>
<p>during qstnr assembly, ensure that</p>
<ul><li><p><code>targets</code> doesn’t include anything else if <code>"none"</code> is present.</p></li>
<li><p><code>values</code> is not empty in the end (the schema neither demands <code>values</code> nor <code>value_scale</code>).</p></li>
<li>
<p>all <code>values</code> subkeys are of the same length (JSON Schema unfortunately <a href="https://stackoverflow.com/questions/54973793/check-that-two-arrays-in-json-have-the-same-size" class="external-link">doesn’t provide any means to do such validation</a>).</p>
<p><code><a href="reference/unnest_qstnr_vals.html">qstnr::unnest_qstnr_vals()</a></code> ensures this implicitly and throws a moderately meaningful error in case of a violation à la:</p>
<pre><code>! In row 575, can't recycle input of size 2 to size 3.</code></pre>
</li>
<li><p>if <code>values</code> and <code>value_sets</code> are provided, the latter contains <code>"values"</code> (we can’t do that in the schema (yet) since the <a href="https://json-schema.org/understanding-json-schema/reference/array.html?highlight=contains#contains" class="external-link"><code>contains</code> keyword</a> was only added with draft 6).</p></li>
<li><p><code>iterators</code> are sensible. the schema only demands an array of arrays – technically anything could be in those level-2 arrays…</p></li>
</ul></li>
<li>
<p>Taplo uses <a href="https://github.com/Stranger6667/jsonschema-rs" class="external-link">jsonschema-rs</a> under the hood which (as of 2023-11) supports JSON Schema up to Draft 7, so we should be able to use more than just Draft 4 features… -&gt; test this!</p>
<p>Furthermore, jsonschema-rs already partially supports the JSON Schema Drafts 2019-09 and 2020-12. Once <a href="https://github.com/tamasfe/taplo/pull/498" class="external-link">tamasfe/taplo#498</a> is merged (or Taplo has <a href="https://github.com/tamasfe/taplo/issues/497#issuecomment-2158519200" class="external-link">switched to boon</a> instead), we should be able to use (supported) features from these newer JSON Schema Drafts and consider porting our schemas to the latest draft iteration.</p>
</li>
<li>
<p>write documentation</p>
<ul><li>general questionnaire principles
<ul><li>all vars that have translatable values <em>must</em> also have <code>values.int</code> defined (in order for <code>as_int_vals</code> target filters to work)</li>
</ul></li>
<li>schema restrictions, rules etc.
<ul><li>allowed characters for footnote <code>id</code>s are based on the MDN recommendations found in the <a href="https://developer.mozilla.org/en-US/docs/Web/HTML/Global_attributes/id" class="external-link"><code>id</code> attribute article</a> (starting with numbers is allowed since the markdown processors usually prepend the <code>id</code>s with a string like <code>fn-</code> anyways)</li>
<li>allowed characters for link <code>id</code>s (“labels” in Pandoc terminology): <code>@</code> is forbidden to prevent clashes with citation keys (which take parsing precedence)</li>
<li>iterators defined via the <code>i</code> array are referrable in inline R code by appending the iterator index (starting by <code>1</code> as it is the convention for vectors in R), i.e. the first iterator is <code>i1</code>, the second <code>i2</code> etc.</li>
</ul></li>
</ul></li>
<li><p>submit schemas to <a href="https://www.schemastore.org/json/" class="external-link">JSON Schema Store</a>? cf. <a href="https://taplo.tamasfe.dev/configuration/developing-schemas.html#publishing" class="external-link uri">https://taplo.tamasfe.dev/configuration/developing-schemas.html#publishing</a></p></li>
<li>
<p>publish stable release</p>
<ul><li>replace all occurrences of <code>https://qstnr.rpkg.dev/dev/</code> with <code>https://qstnr.rpkg.dev/</code> in schemas (and elsewhere) -&gt; change default to <code>schema_url(dev = FALSE)</code> <em>thanks to our HTTP redirects we can actually do this already!</em>
</li>
<li>submit to CRAN</li>
</ul></li>
<li>
<p>further investigate shortcomings of taplo’s schema validation</p>
<p>e.g. adding a forbidden survey config key <code>qstnr.introo</code> doesn’t trigger a validation error in taplo (compare with <a href="https://www.jsonschemavalidator.net/" class="external-link">this online validator</a> which properly errors)</p>
</li>
<li>
<p>implement fns to <em>write</em> TOML. requires an R package providing support for this since RcppTOML only offers read support. we could write an R package that offers <a href="https://docs.rs/taplo/latest/taplo/" class="external-link">taplo</a> or <a href="https://docs.rs/toml/latest/toml/" class="external-link">toml</a> crate bindings; relevant resources:</p>
<ul><li><a href="https://github.com/r-rust/faq" class="external-link">Publishing R packages with Rust code on CRAN</a></li>
<li><a href="https://extendr.github.io/rextendr/" class="external-link">rextendr R package</a></li>
<li><a href="https://github.com/dbdahl/cargo-framework" class="external-link">cargo R package</a></li>
</ul></li>
<li>
<p>Have a look at the following R packages and check whether we should take inspiration from them:</p>
<ul><li><a href="https://rubenarslan.github.io/codebook/" class="external-link">codebook</a></li>
<li><a href="https://juba.github.io/questionr/" class="external-link">questionr</a></li>
</ul></li>
<li>
<p>integrate with suitable open-source survey “servers”. candidates include:</p>
<ul><li>
<a href="https://www.limesurvey.org/blog/product-news/914-limesurvey-6" class="external-link">LimeSurvey 6</a>
<ul><li>still sucks massively: PHP app based on LAMP stack; terrible community both in technical and organizational terms; awful dev experience due to basically <a href="https://manual.limesurvey.org/index.php?search=API" class="external-link">unusable/undocumented APIs</a>)</li>
<li>to sum up: LimeSurvey has design flaws beyond repairability and is not intended to be used by programmers but only targets non-programmatic usage</li>
</ul></li>
<li>
<a href="https://formbricks.com/" class="external-link"><strong>Formbricks</strong></a>!
<ul><li>offers <a href="https://formbricks.com/docs/api/client/overview" class="external-link">REST APIs</a> incl. the management API’s <a href="https://formbricks.com/docs/api/management/surveys" class="external-link">survey sub-API</a> that i.a. offers an <a href="https://formbricks.com/docs/api/management/surveys#create-survey" class="external-link">endpoint to create surveys</a>; this might not be enough for our use case, though (create the <em>whole</em> survey (incl. routing and everything) from data submitted via API)</li>
<li>development is very active and fast, but currently Formbricks still lacks a few mandatory features I think -&gt; need to thoroughly investigate/test!</li>
</ul></li>
<li>see this <a href="https://formbricks.com/blog/best-open-source-survey-software-2023" class="external-link">short overview</a> for 3 more OSS projects (of which none matches what we want 😐)</li>
</ul></li>
</ul><p>Should we build some kind of <a href="https://formr.org/" class="external-link">formr</a> integration? qstnr’s functionality would probably be a perfect fit…</p>
<div class="section level2">
<h2 id="fundamentals">fundamentals<a class="anchor" aria-label="anchor" href="#fundamentals"></a></h2>
<ul><li>
<p>make <code>value_sets</code> part “directionless” by</p>
<ul class="task-list"><li><label><input type="checkbox" checked>always sorting the definitions ascendingly, allow new sentinel <code>desc:</code> in <code>value_sets</code></label></li>
<li><label><input type="checkbox" checked>implementing <code>desc:</code> interpretation</label></li>
<li><label><input type="checkbox">communicating new requirement/guarantee in doc</label></li>
<li><label><input type="checkbox">validating new requirement in code!</label></li>
</ul></li>
<li><p>implement some kind of sentinel (like <code>free_text:</code>) to signify free text fields? (label would follow)</p></li>
<li><p>should we introduce another item key <code>values_ptype</code> (or the like) to specify what we first wanted via <code>values = "{ val_ptype(type = date, size = 1L) }"</code> (which the schema doesn’t allow anymore)? or come up with a better/proper syntax for value <em>validation</em>, depending on ptype (to e.g. ensure a date lies in between a specific range), i.e. maybe directly use checkmate?</p></li>
</ul></div>
</div>

  </main></div>


    <footer><div class="pkgdown-footer-left">
  <p>Developed by Salim Brüggemann.</p>
</div>

<div class="pkgdown-footer-right">
  <p>Site built with <a href="https://pkgdown.r-lib.org/" class="external-link">pkgdown</a> 2.1.1.9000.</p>
</div>

    </footer></div>





  </body></html>

